<?php

namespace App\Http\Controllers;

use App\Models\Telefono;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;

class TelefonoController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(): JsonResponse
    {
        $items = Telefono::all();

        return response()->json([
            'success' => true,
            'data' => $items,
            'message' => 'Registros obtenidos correctamente',
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request): JsonResponse
    {
        $payload = $request->only((new Telefono())->getFillable());
        $telefono = Telefono::create($payload);

        return response()->json([
            'success' => true,
            'data' => $telefono,
            'message' => 'Registro creado correctamente',
        ], 201);
    }

    /**
     * Display the specified resource.
     */
    public function show(Telefono $telefono): JsonResponse
    {
        return response()->json([
            'success' => true,
            'data' => $telefono,
            'message' => 'Registro obtenido correctamente',
        ], 200);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Telefono $telefono): JsonResponse
    {
        $payload = $request->only((new Telefono())->getFillable());
        $telefono->update($payload);

        return response()->json([
            'success' => true,
            'data' => $telefono,
            'message' => 'Registro actualizado correctamente',
        ], 200);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Telefono $telefono): JsonResponse
    {
        $telefono->delete();

        return response()->json([
            'success' => true,
            'message' => 'Registro eliminado correctamente',
        ], 200);
    }
}